# =================================================================================================
#<profile4xi profile = "10" />
#<program4xi program = "import2ball4xi.py">
#<abstract4xi abstract = "imports one selected zap module creating scope services"/>
#<refer4xi reference = "zapimport2ball4xi.py"/> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'import2ball4xi' ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

# ------------------------------------------------------------------------------------- 
# CONSTANT CODES TO PROCESS ZAP-KOWLEDGEBASE  
# -------------------------------------------------------------------------------------     
cc2sense       = '2xi'
cc2reason      = '4xi'
cc2ace         = '8xi'
cc2direction   = 1
cc2distance    = 2
cc2layer       = 3

cc2area4layer  = 1
cc2color4layer = 2
cc2qty4layer   = 3
cc2area4node   = 4

cc2identity    = 4 
cc2color       = 5
cc2fire        = 6
cc2cluster     = 7
cc2ray         = 8
cc2deviation   = 9 
cc2super       = 10
cc2message     = 11
cc2actor       = 12
cc2type        = 13
cc2home        = 14
cc2previous    = 15
cc2next        = 16
cc2last        = 17
cc2first       = 18
cc2module      = 19
#"
#"/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # most-common ones
    import datetime
    import time
    from time import gmtime, strftime         
except:
    pass
     
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from yoke4xi import yoke4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "


#"
#"/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing

#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from process4xi import Process4Xi                                                                               #  
from time4xi import time4xi

#"
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "import2ball4xi usage = "
#   importing a selected zapped module for scoping
#">                      
# -------------------------------------------------------------------------------------------------    
def import2ball4xi(sphere2target, file2target):
    '''
    importing a selected zapped module for scoping
    '''

    # -------------------------------------------------------------------------------------------------
    # INITIALIZE                              
    # -------------------------------------------------------------------------------------------------    

    context2yoke   = {}

    context2yoke['path']           = 'pass'
    context2yoke['operation']      = 'pass'
    context2yoke['ack2debug']      = False  # set True to debug actions
    context2yoke['ack2debug4try']  = False  # set True to debug also trials
    context2yoke['ack2debug4yoke'] = False  # set True when testing yoke4xi !
    context2yoke['message']        = 'pass'    
    yoke4xi (context2yoke)
    
    context2yoke['message'] = '<!-- ==================================================================================================== -->'
    yoke4xi (context2yoke)  
    context2yoke['message'] = '<!--' + "(Step 0A/33) OF IMPORT2BALL4XI - PASSED SPHERE2TARGET: " + str(sphere2target) + '-->'
    yoke4xi (context2yoke)
    
    context2yoke['message'] = '<!--' + "(Step 0A/33) OF IMPORT2BALL4XI - PASSED SPHERE2TARGET: " + str(sphere2target) + '-->'
    yoke4xi (context2yoke)
    
    context2yoke['message'] = '<!--' + "(Step 0B/33) OF IMPORT2BALL4XI - PASSED FILE2TARGET: " + str(file2target) + '-->'
    yoke4xi (context2yoke)
        
    context2yoke['message'] = '<!-- ==================================================================================================== -->'
    yoke4xi(context2yoke)   
    
    AlphaKB4Direction = {
        0: 'zero',
        1: 'one',
        2: 'two',
        3: 'three',
        4: 'four',
        5: 'five',
        6: 'six',
        7: 'seven',
        8: 'eight'}
    

        
    # ---------------------------------------------------------------------------------------------
    # (STEP 1/33) OF IMPORT2BALL4XI - DEFINE SENSE, REASON AND ACE OUTPUT HTML FILE
    # --------------------------------------------------------------------------------------------- 
    extension2file = '.html'
    base2path= '..//..//web//html//'  # fix 12th of August 2011
    context2yoke['message'] = '<!-- ==================================================================================================== -->'
    yoke4xi(context2yoke)   
    context2yoke['message'] = '<!--' + "(Step 1A/33) OF IMPORT2BALL4XI - TRYING TO DEFINE OUTPUT HTML FILE " + time4xi() + '-->'
    yoke4xi(context2yoke)      
    context2yoke['message'] = '<!-- ==================================================================================================== -->'
    yoke4xi(context2yoke)  
     
    try:                                   
        path2scope  = base2path + file2target + extension2file
        path2scope  =  path2scope.replace("_","-")                                                                                     # change names suitable for CMS
          
        context2yoke['message'] = '<!--' + "(Step 1B/33) OF IMPORT2BALL4XI - SET FILE2SCOPE  TO: " + path2scope + '-->'                #
        yoke4xi (context2yoke)          
    except:
        context2yoke['message'] = '<!--' + "(Step 1Z/33) OF IMPORT2BALL4XI *** FAILED TO DEFINE OUTPUT HTML FILE " + time4xi() + '-->'
        yoke4xi(context2yoke)
    
    
    # ---------------------------------------------------------------------------------------------
    # (STEP 2/33) OF IMPORT2BALL4XI - OPEN OUTPUT FILE
    # ---------------------------------------------------------------------------------------------         
    context2yoke['message'] = '<!--' + "(Step 2A/33) OF IMPORT2BALL4XI - TRYING TO OPEN OUTPUT FILE: " + path2scope + '-->'  
    yoke4xi(context2yoke)

    try: 
        context2yoke['path']      = path2scope
        context2yoke['operation'] = 'open'
        context2yoke['message']   = '<!--' + "(Step 2B/33) OF IMPORT2BALL4XI - OPENED FILE2SCOPE: "  + path2scope + '-->'              #
        yoke4xi(context2yoke) 

    except:
        context2yoke['operation'] = 'pass'
        context2yoke['message'] = '<!--' + "(Step 2Z/33) OF IMPORT2BALL4XI *** FAILED TO OPEN OUTPUT FILE: " + path2scope + '-->'
        yoke4xi(context2yoke)
        
    # ---------------------------------------------------------------------------------------------
    # SETTINGS FOR WRITING TO FILE
    # ---------------------------------------------------------------------------------------------   
    context2yoke['operation'] = 'write'    

    # ---------------------------------------------------------------------------------------------
    # DOCUMENT TYPE - new in HTML 5.0: more simple
    # ---------------------------------------------------------------------------------------------
    context2yoke['message'] = '<!DOCTYPE HTML>'
    yoke4xi(context2yoke)    
    
    # ---------------------------------------------------------------------------------------------
    # START OF HTML - new: manifest file for offline situations
    # ---------------------------------------------------------------------------------------------
    context2yoke['message'] = '<html manifest="../manifest/telescope.manifest" xmlns="http://www.w3.org/1999/xhtml"/>'
    yoke4xi(context2yoke)   
            
    # ---------------------------------------------------------------------------------------------
    # HEADER START
    # ---------------------------------------------------------------------------------------------    
    context2yoke['message'] = '<head>'
    yoke4xi(context2yoke)           
    
    # ---------------------------------------------------------------------------------------------
    # META START
    # ---------------------------------------------------------------------------------------------    
    context2yoke['message'] = '<meta name="Sphere4Xi" content="Sphere for Telescope4Xi" />'
    yoke4xi(context2yoke)   
        
    context2yoke['message'] = '<meta name="Context4Xi" content="HTML,CSS,XML,JavaScript,Python" />'
    yoke4xi(context2yoke)   
   
    context2yoke['message'] = '<meta name="Copyright" content="Small & Smart" />'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '<meta charset="ISO-8859-1" />'
    yoke4xi(context2yoke)   
        
    # ---------------------------------------------------------------------------------------------
    # META END
    # ---------------------------------------------------------------------------------------------              
    
    # ---------------------------------------------------------------------------------------------
    # STYLE START - INSIDE HEAD SO FAR - 
    # ---------------------------------------------------------------------------------------------       
    context2yoke['message'] = '<style type="text/css" media="all">'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '@import "../css/4xi.css";'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '@import "../css/link4xi.css";'
    yoke4xi(context2yoke)   
   
    context2yoke['message'] = '@import "../css/p4xi.css";'
    yoke4xi(context2yoke)   
 
    context2yoke['message'] = '@import "../css/table4xi.css";'
    yoke4xi(context2yoke)   
  
    context2yoke['message'] = '@import "../css/tr4xi.css";'
    yoke4xi(context2yoke)   
 
    context2yoke['message'] = '@import "../css/td4xi.css";'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '</style>'
    yoke4xi(context2yoke)   
        
    # ---------------------------------------------------------------------------------------------
    # STYLE END
    # ---------------------------------------------------------------------------------------------       
            
    # ---------------------------------------------------------------------------------------------
    # HEADER END
    # ---------------------------------------------------------------------------------------------     
    context2yoke['message'] = '</head>'
    yoke4xi(context2yoke)   
        
    # ---------------------------------------------------------------------------------------------
    # START OF BODY
    # ---------------------------------------------------------------------------------------------    
    context2yoke['message'] = '<body>'
    yoke4xi(context2yoke)   
    
    
    # ---------------------------------------------------------------------------------------------
    # CREATE
    # --------------------------------------------------------------------------------------------- 
    context2yoke['operation'] = 'pass'  
    context2yoke['message'] = '<p>CREATING TELESCOPE!</p>'
    yoke4xi(context2yoke)   
    
    context2yoke['operation'] = 'write'  
    # ---------------------------------------------------------------------------------------------
    # ACTIVATE
    # --------------------------------------------------------------------------------------------- 
    context2yoke['message'] = '<!-- --------------------------------------------------------------------------------------------- -->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '<!-- DIRECT-->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '<!-- --------------------------------------------------------------------------------------------- -->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '<p>TELESCOPE - Release: 17.21 Version: ' + time4xi() + '</p>'
    yoke4xi(context2yoke)   
        
    # ---------------------------------------------------------------------------------------------
    # MANIFEST!
    # ---------------------------------------------------------------------------------------------      
    context2yoke['message'] = '<object data="manifest4xi.py">' + '<!-- MANIFEST-->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
            
    # ---------------------------------------------------------------------------------------------
    # ZERO DIRECT!
    # ---------------------------------------------------------------------------------------------      
    context2yoke['message'] = '<object data="direct0000zero4xi.py">' + '<!-- ZERO DIRECT-->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
        
    # ---------------------------------------------------------------------------------------------
    # ONE DIRECT!
    # ---------------------------------------------------------------------------------------------                                          
    context2yoke['message'] = '<object data="direct0000one4xi.py">' + '<!-- ONE DIRECT-->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
            
    # ---------------------------------------------------------------------------------------------
    # TWO DIRECT!
    # ---------------------------------------------------------------------------------------------      
    context2yoke['message'] = '<object data="direct0000two4xi.py">' + '<!-- TWO DIRECT-->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
        
    # ---------------------------------------------------------------------------------------------
    # THREE DIRECT!
    # ---------------------------------------------------------------------------------------------      
    context2yoke['message'] = '<object data="direct0000three4xi.py">' + '<!-- THREE DIRECT-->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
        
    # ---------------------------------------------------------------------------------------------
    # FOUR DIRECT!
    # ---------------------------------------------------------------------------------------------      
    context2yoke['message'] = '<object data="direct0000four4xi.py">' + '<!-- FOUR DIRECT-->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
        
    
    # ---------------------------------------------------------------------------------------------
    # FIVE DIRECT!
    # ---------------------------------------------------------------------------------------------      
    context2yoke['message'] = '<object data="direct0000five4xi.py">' + '<!-- FIVE DIRECT-->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
        
    
    # ---------------------------------------------------------------------------------------------
    # SIX DIRECT!
    # ---------------------------------------------------------------------------------------------      
    context2yoke['message'] = '<object data="direct0000six4xi.py">' + '<!-- SIX DIRECT-->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
        
    
    # ---------------------------------------------------------------------------------------------
    # SEVEN DIRECT!
    # ---------------------------------------------------------------------------------------------      
    context2yoke['message'] = '<object data="direct0000seven4xi.py">' + '<!-- SEVEN DIRECT-->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
        
    
    # ---------------------------------------------------------------------------------------------
    # EIGHT DIRECT!
    # ---------------------------------------------------------------------------------------------      
    context2yoke['message'] = '<object data="direct0000eight4xi.py">' + '<!-- EIGHT DIRECT-->'
    yoke4xi(context2yoke)   
        
    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
        
                                      
    # ---------------------------------------------------------------------------------------------
    # RUNNING
    # ---------------------------------------------------------------------------------------------     

                
    # ---------------------------------------------------------------------------------------------
    # START OF PARAMETERS
    # ---------------------------------------------------------------------------------------------         
    context2yoke['operation'] = 'pass'
    context2yoke['message'] = '<!-- --------------------------------------------------------------------------------------------- -->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '<!--' + "(Step 1/33) OF IMPORT2BALL4XI - TRYING TO EMBED SPHERE TO SCOPE " + time4xi() + '-->'
    yoke4xi(context2yoke)   

    context2yoke['message'] = '<!-- --------------------------------------------------------------------------------------------- -->'
    yoke4xi(context2yoke)   
           
    context2yoke['message'] = '<!--' + "(Step 1/33) OF IMPORT2BALL4XI - TRYING TO EMBED SPHERE TO SCOPE " + time4xi() + '-->'
    yoke4xi(context2yoke)   
           
            
    try:
        
        keys2direction = sphere2target.keys()
        for key2direction in sorted(keys2direction):
            alpha2direction = AlphaKB4Direction[key2direction]                                                      # zero, one... eight        
                                                                                                                    # ===============
                                                                                                                    # DIRECTION:  1
                                                                                                                    # ===============                
            kb2layer = sphere2target[key2direction]
            if len(kb2layer) > 0:
                keys2layer = kb2layer.keys()
                for key2layer in sorted(keys2layer):
                    
                    if key2layer == 0:
                        alpha2layer = '0000'
                    else:
                        if key2layer < 10:
                            alpha2layer = '000' + str(key2layer)
                        else:
                           if key2layer < 100:
                               alpha2layer = '00' + str(key2layer)
                           else:
                               if key2layer < 1000:
                                   alpha2layer = '0' + str(key2layer)
                               else:
                                   alpha2layer = str(key2layer)              
                    
                    context2yoke['operation'] = 'write'
                    context2yoke['message'] = '<!-- --------------------------------------------------------------------------------------------- -->'
                    yoke4xi(context2yoke)   
          
                    context2yoke['message'] = '<!-- LAY' + alpha2layer.upper() + alpha2direction.upper() + '-->'
                    yoke4xi(context2yoke)   
                     
                    context2yoke['message'] = '<!-- --------------------------------------------------------------------------------------------- -->'
                    yoke4xi(context2yoke)   
                           
                    context2yoke['message'] = '<object data="lay' + alpha2layer + alpha2direction + '4xi.py">' + '<!-- LAY' + alpha2layer.upper() + alpha2direction.upper() + '-->'
                    yoke4xi(context2yoke)   
   
                                                                                                                    # ------------------------------
                                                                                                                    # LAYER:  10
                                                                                                                    # ------------------------------                
                    kb2node = sphere2target[key2direction] [key2layer]
                    keys2node = kb2node.keys()
                    for key2node in sorted(keys2node):
      
                        context2yoke['message'] = '<!-- --------------------------------------------------------------------------------------------- -->'
                        yoke4xi(context2yoke)   
                              
                        context2yoke['message'] = '<!-- ' + str(key2node).upper() + ' OF LAYER ' + alpha2layer.upper() + alpha2direction.upper() + '-->'
                        yoke4xi(context2yoke)   
                            
                        context2yoke['message'] = '<!-- --------------------------------------------------------------------------------------------- -->'
                        yoke4xi(context2yoke)   
                               
                        context2yoke['message'] = '<object data="' + str(key2node) + '">' + '<!--' + str(key2node).upper() + '-->'
                        yoke4xi(context2yoke)   
   
                                                                                                                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                                                                                                                    # NODE:  0x0y19z
                                                                                                                    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~                    
                                                                                                                    # '<!--', "sphere2target[", key2direction, "][", key2layer, "][", key2node, "]: ", kb2node [key2node]
                        # ----------------------------------------------------------------------------------------------
                        # SENSE KB
                        # ----------------------------------------------------------------------------------------------                                                                                                                           
                        kb2sense = kb2node [key2node] [cc2sense]
                        keys2sense = kb2sense.keys()
                        for key2sense in sorted(keys2sense):
         
                            context2yoke['message'] = '<!--' + "sphere2target[" + str(key2direction) + "][" + str(key2layer) + "][" + str(key2node) + "][" + str(key2sense) + "]: " + str(kb2node [key2node] [cc2sense] [key2sense]) + '-->'
                            yoke4xi(context2yoke)   
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 1 ]:  1
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 2 ]:  10
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 3 ]:  {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 4 ]:  dragon0x0y19z
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 5 ]:  #9BA2A2
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 6 ]:  68
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 7 ]:  1
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 8 ]:  19.0
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 9 ]:  9
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 10 ]:  1
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 11 ]:  {started; reason-object4xi-started: function reason_object4xi at 0x029FF6A8; time: 05:37:51 01/08/11 Pacific Standard Time}
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 12 ]:  reason_object4xi
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 13 ]:  1
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 14 ]:  -0x-0y-0z
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 15 ]:  -0x-0y-0z
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 16 ]:  0x0y39z
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 17 ]:  0x0y59z
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 18 ]:  0x0y19z
                                                                                                                    # sphere2target[ 1 ][ 10 ][ 0x0y19z ][ 19 ]:  reason_object4xi.py
                                                                                           
                        [1]
                        # ----------------------------------------------------------------------------------------------
                        # DIRECTION OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                          
                        context2yoke['operation'] = 'pass'
                        context2yoke['message'] = '<!--' + "(Step 21A/33) OF IMPORT2BALL4XI - TRYING TO PRINT DIRECTION" + '-->'
                        yoke4xi(context2yoke)     
                        try:                                                                                                
                            context2yoke['operation'] = 'write'
                            context2yoke['message'] = '<param name="direction2node"' + ' value = "' + str(kb2node [key2node] [cc2sense] [cc2direction]) + '">' + '<!-- DIRECTION OF NODE-->'
                            yoke4xi(context2yoke)   
   
                        except:
                            context2yoke['operation'] = 'pass'
                            context2yoke['message'] = '<!--' + "(Step 21Z5/33) OF IMPORT2BALL4XI ** YIELDED WITH DIRECTION OF NODE **" + '-->'
                            yoke4xi(context2yoke)   

                        [2]
                        # ----------------------------------------------------------------------------------------------
                        # DISTANCE OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                          
                        context2yoke['operation'] = 'pass'
                        context2yoke['message'] = '<!--' + "(Step 22A/33) OF IMPORT2BALL4XI - TRYING TO PRINT DISTANCE OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                     
                        try:
                            context2yoke['operation'] = 'write'                               
                            context2yoke['message'] = '<param name="distance2node"' + ' value = "'+ str(kb2node [key2node] [cc2sense] [cc2distance]) + '">' + '<!-- DISTANCE OF NODE-->'
                            yoke4xi(context2yoke)   
                                  
                        except:
                            context2yoke['operation'] = 'pass'            
                            context2yoke['message'] = '<!--' + "(Step 22Z/33) OF IMPORT2BALL4XI ** YIELDED WITH DISTANCE OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
   
                        [3]
                        # ----------------------------------------------------------------------------------------------
                        # LAYER KNOWLEDGEBASE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                              
                        kb2layer = kb2node [key2node] [cc2sense] [cc2layer]
                        
                        [31]
                        # ----------------------------------------------------------------------------------------------
                        # LAYER AREA - IN LAYER KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                          
                        context2yoke['operation'] = 'pass'
                        context2yoke['message'] = '<!--' + "(Step 231/33) OF IMPORT2BALL4XI - TRYING TO PRINT LAYER AREA" + '-->'
                        yoke4xi(context2yoke)   
                                         
                        try:
                            context2yoke['operation'] = 'write'                             
                            context2yoke['message'] = '<param name="area4layer"' + ' value = "'+ str(kb2node [key2node] [cc2sense] [cc2layer] [cc2area4layer]) + '">' + '<!-- LAYER AREA-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                                     
                            context2yoke['message'] = '<!--' + "(Step 231Z/33) OF IMPORT2BALL4XI ** YIELDED WITH LAYER AREA **" + '-->'
                            yoke4xi(context2yoke)   
                                
                        [32]
                        # ----------------------------------------------------------------------------------------------
                        # LAYER COLOR - IN LAYER KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                          
                        context2yoke['operation'] = 'pass'  
                        context2yoke['message'] = '<!--' + "(Step 232/33) OF IMPORT2BALL4XI - TRYING TO PRINT LAYER COLOR" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            context2yoke['operation'] = 'write'                               
                            context2yoke['message'] = '<param name="color4layer"' + ' value = "'+ str(kb2node [key2node] [cc2sense] [cc2layer] [cc2color4layer]) + '">' + '<!-- COLOR OF LAYER-->'
                            yoke4xi(context2yoke)   
                               
                        except:
                            context2yoke['operation'] = 'pass'                                    
                            context2yoke['message'] = '<!--' + "(Step 232Z/33) OF IMPORT2BALL4XI ** YIELDED WITH LAYER COLOR **" + '-->'
                            yoke4xi(context2yoke)   
                                                         
                        [33]
                        # ----------------------------------------------------------------------------------------------
                        # QUANTITY OF NODES AT LAYER - IN LAYER KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                          
                        context2yoke['operation'] = 'pass'
                        context2yoke['message'] = '<!--' + "(Step 233/33) OF IMPORT2BALL4XI - TRYING TO PRINT QUANTITY OF NODES AT LAYER" + '-->'
                        yoke4xi(context2yoke)   
                                      
                        try:
                            context2yoke['operation'] = 'write'                             
                            context2yoke['message'] = '<param name="qty4layer"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2layer] [cc2qty4layer]) + '">' + '<!-- QUANTITY OF NODES AT LAYER-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                          
                            context2yoke['message'] = '<!--' + "(Step 233Z/33) OF IMPORT2BALL4XI ** YIELDED WITH QUANTITY OF NODES AT LAYER **" + '-->'
                            yoke4xi(context2yoke)   
                                 
                        [34]
                        # ----------------------------------------------------------------------------------------------
                        # AREA PER NODE AT LAYER - IN LAYER KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                          
                        context2yoke['operation'] = 'pass'
                        context2yoke['message'] = '<!--' + "(Step 234/33) OF IMPORT2BALL4XI - TRYING TO PRINT AREA PER NODE AT LAYER" + '-->'
                        yoke4xi(context2yoke)   
                                      
                        try:
                            context2yoke['operation'] = 'write'                                 
                            context2yoke['message'] = '<param name="area4node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2layer] [cc2area4node]) + '">' + '<!-- AREA PER NODE AT LAYER-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                                    
                            context2yoke['message'] = '<!--' + "(Step 234Z/33) OF IMPORT2BALL4XI ** YIELDED WITH AREA PER NODE AT LAYER **" + '-->'
                            yoke4xi(context2yoke)   
                                                                                                 
                        [4]
                        # ----------------------------------------------------------------------------------------------
                        # IDENTITY OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'     
                        context2yoke['message'] = '<!--' + "(Step 24A/33) OF IMPORT2BALL4XI - TRYING TO PRINT IDENTITY OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            context2yoke['operation'] = 'write'                               
                            context2yoke['message'] = '<param name="identity2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2identity]) + '">' + '<!-- IDENTITY OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                                   
                            context2yoke['message'] = '<!--' + "(Step 24Z/33) OF IMPORT2BALL4XI ** YIELDED WITH IDENTITY OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                     
                        [5]
                        # ----------------------------------------------------------------------------------------------
                        # COLOR OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass' 
                        context2yoke['message'] = '<!--' + "(Step 25A/33) OF IMPORT2BALL4XI - TRYING TO PRINT COLOR OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            context2yoke['operation'] = 'write'                             
                            context2yoke['message'] = '<param name="color2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2color]) + '">' + '<!-- COLOR OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                                
                            context2yoke['message'] = '<!--' + "(Step 25Z/33) OF IMPORT2BALL4XI ** YIELDED WITH COLOR OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                     
                        [6]
                        # ----------------------------------------------------------------------------------------------
                        # FIRE OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'                            
                        context2yoke['message'] = '<!--' + "(Step 26A/33) OF IMPORT2BALL4XI - TRYING TO PRINT FIRE OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            context2yoke['operation'] = 'write'                              
                            context2yoke['message'] = '<param name="fire2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2fire]) + '">' + '<!-- FIRE OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                               
                            context2yoke['message'] = '<!--' + "(Step 26Z/33) OF IMPORT2BALL4XI ** YIELDED WITH FIRE OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                     
                        [7]
                        # ----------------------------------------------------------------------------------------------
                        # CLUSTER OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                           
                        context2yoke['operation'] = 'pass'
                        context2yoke['message'] = '<!--' + "(Step 27A/33) OF IMPORT2BALL4XI - TRYING TO PRINT CLUSTER OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            context2yoke['operation'] = 'write'                               
                            context2yoke['message'] = '<param name="cluster2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2cluster]) + '">' + '<!-- CLUSTER OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                           
                            context2yoke['message'] = '<!--' + "(Step 27Z/33) OF IMPORT2BALL4XI ** YIELDED WITH CLUSTER OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                     
                        [8]
                        # ----------------------------------------------------------------------------------------------
                        # RAY OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'                                
                        context2yoke['message'] = '<!--' + "(Step 28A/33) OF IMPORT2BALL4XI - TRYING TO PRINT RAY OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            context2yoke['operation'] = 'write'                            
                            context2yoke['message'] = '<param name="ray2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2ray]) + '">' + '<!-- RAY OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                             
                            context2yoke['message'] = '<!--' + "(Step 28Z/33) OF IMPORT2BALL4XI ** YIELDED WITH RAY OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                     
                        [9]
                        # ----------------------------------------------------------------------------------------------
                        # DEVIATION OF RAY - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'    
                        context2yoke['message'] = '<!--' + "(Step 29A/33) OF IMPORT2BALL4XI - TRYING TO PRINT DEVIATION OF RAY" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            context2yoke['operation'] = 'write'                              
                            context2yoke['message'] = '<param name="deviation2ray"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2deviation]) + '">' + '<!-- DEVIATION OF RAY-->'
                            yoke4xi(context2yoke)   
                               
                        except:
                            context2yoke['operation'] = 'pass'                                  
                            context2yoke['message'] = '<!--' + "(Step 29Z/33) OF IMPORT2BALL4XI ** YIELDED WITH DEVIATION OF RAY **" + '-->'
                            yoke4xi(context2yoke)   
                                     
                        [10]
                        # ----------------------------------------------------------------------------------------------
                        # SUPER OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                           
                        context2yoke['operation'] = 'pass'                                 
                        context2yoke['message'] = '<!--' + "(Step 210A/33) OF IMPORT2BALL4XI - TRYING TO PRINT SUPER OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                      
                        try:
                            context2yoke['operation'] = 'write'                   
                            context2yoke['message'] = '<param name="super2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2super]) + '">' + '<!-- SUPER OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                     
                            context2yoke['message'] = '<!--' + "(Step 210Z/33) OF IMPORT2BALL4XI ** YIELDED WITH SUPER OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                     
                        [11]
                        # ----------------------------------------------------------------------------------------------
                        # MESSAGE OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'                
                        context2yoke['message'] = '<!--' + "(Step 211A/33) OF IMPORT2BALL4XI - TRYING TO PRINT MESSAGE OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                         
                        try:
                            context2yoke['operation'] = 'write'                        
                            context2yoke['message'] = '<param name="message2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2message]) + '">' + '<!-- MESSAGE OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                     
                            context2yoke['message'] = '<!--' + "(Step 211Z/33) OF IMPORT2BALL4XI ** YIELDED WITH MESSAGE OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
       
                                                                                                                    # provide telescope message for missing ones!                            
                                 
                            context2yoke['message'] = '<param name="message2node"' + ' value="{yielded; message-yielded-by-telescope4xi}">' + '<!-- MESSAGE OF NODE PROVIDED BY TELESCOPE-->'
                            yoke4xi(context2yoke)   
                                     
                        [12]
                        # ----------------------------------------------------------------------------------------------
                        # ACTOR OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'                            
                        context2yoke['message'] = '<!--' + "(Step 212A/33) OF IMPORT2BALL4XI - TRYING TO PRINT ACTOR OF NODE " + '-->'
                        yoke4xi(context2yoke)   
                                         
                        try:
                            context2yoke['operation'] = 'write'                            
                            context2yoke['message'] = '<param name="actor2node"' + ' value ="'+ str(kb2node [key2node] [cc2sense] [cc2actor]) + '">' + '<!-- ACTOR OF NODE-->'
                            yoke4xi(context2yoke)   
                               
                        except:
                            context2yoke['operation'] = 'pass'                                
                            context2yoke['message'] = '<!--' + "(Step 212Z/33) OF IMPORT2BALL4XI ** YIELDED WITH ACTOR OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                       
                            context2yoke['message'] = '<param name="actor2node"' + ' value ="telescope4xi.py">' + '<!-- ACTOR OF NODE PROVIDED BY TELESCOPE-->'
                            yoke4xi(context2yoke)   
                                  
                                                              
                        [13]
                        # ----------------------------------------------------------------------------------------------
                        # TYPE OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'                     
                        context2yoke['message'] = '<!--' + "(Step 213A/33) OF IMPORT2BALL4XI - TRYING TO PRINT TYPE OF NODE"  + '-->'
                        yoke4xi(context2yoke)   
                                       
                        try:
                            context2yoke['operation'] = 'write'                     
                            context2yoke['message'] = '<param name="type2node"' + ' value ="'+ str(kb2node [key2node] [cc2sense] [cc2type]) + '">' + '<!-- TYPE OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                                               
                            context2yoke['message'] = '<!--' + "(Step 213Z/33) OF IMPORT2BALL4XI ** YIELDED WITH TYPE OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                     
                        [14]
                        # ----------------------------------------------------------------------------------------------
                        # HOME LINK OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'                                   
                        context2yoke['message'] = '<!--' + "(Step 214A/33) OF IMPORT2BALL4XI - TRYING TO PRINT HOME LINK OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            context2yoke['operation'] = 'write'                     
                            context2yoke['message'] = '<param name="home2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2home]) + '">' + '<!-- HOME LINK OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                                  
                            context2yoke['message'] = '<!--' + "(Step 214Z/33) OF IMPORT2BALL4XI ** YIELDED WITH HOME LINK OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                    
                        [15]
                        # ----------------------------------------------------------------------------------------------
                        # PREVIOUS LINK OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'                          
                        context2yoke['message'] = '<!--' + "(Step 215A/33) OF IMPORT2BALL4XI - TRYING TO PRINT PREVIOUS LINK OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            context2yoke['operation'] = 'write'                         
                            context2yoke['message'] = '<param name="previous2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2previous]) + '">' + '<!-- PREVIOUS LINK OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                       
                            context2yoke['message'] = '<!--' + "(Step 215Z/33) OF IMPORT2BALL4XI ** YIELDED WITH PREVIOUS LINK OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                    
                        [16]
                        # ----------------------------------------------------------------------------------------------
                        # NEXT LINK OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'                          
                        context2yoke['message'] = '<!--' + "(Step 216A/33) OF IMPORT2BALL4XI - TRYING TO PRINT NEXT LINK OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                
                        try:
                            context2yoke['operation'] = 'write'                       
                            context2yoke['message'] = '<param name="next2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2next]) + '">' + '<!-- NEXT LINK OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                  
                            context2yoke['message'] = '<!--' + "(Step 216Z/33) OF IMPORT2BALL4XI ** YIELDED WITH NEXT LINK OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                     
                        [17]
                        # ----------------------------------------------------------------------------------------------
                        # LAST LINK OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'                          
                        context2yoke['message'] = '<!--' + "(Step 217A/33) OF IMPORT2BALL4XI - TRYING TO PRINT LAST LINK OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                         
                        try:
                            context2yoke['operation'] = 'write'                                 
                            context2yoke['message'] = '<param name="last2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2last]) + '">' + '<!-- LAST LINK OF NODE-->'
                            yoke4xi(context2yoke)   
                                
                        except:
                            context2yoke['operation'] = 'pass'                            
                            context2yoke['message'] = '<!--' + "(Step 217Z/33) OF IMPORT2BALL4XI ** YIELDED WITH LAST LINK OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                     
                        [18]
                        # ----------------------------------------------------------------------------------------------
                        # FIRST LINK OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'                                   
                        context2yoke['message'] = '<!--' + "(Step 218A/33) OF IMPORT2BALL4XI - TRYING TO PRINT FIRST LINK OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            context2yoke['operation'] = 'write'                          
                            context2yoke['message'] = '<param name="first2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2first]) + '">' + '<!-- FIRST LINK OF NODE-->'
                            yoke4xi(context2yoke)                                                            
                        except:
                            context2yoke['operation'] = 'pass'                           
                            context2yoke['message'] = '<!--' + "(Step 218Z/33) OF IMPORT2BALL4XI ** YIELDED WITH FIRST LINK OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                     
                        [19]
                        # ----------------------------------------------------------------------------------------------
                        # MODULE LINK OF NODE - IN SENSE KNOWLEDGEBASE
                        # ----------------------------------------------------------------------------------------------                                          
                        context2yoke['operation'] = 'pass'                         
                        context2yoke['message'] = '<!--' + "(Step 219A/33) OF IMPORT2BALL4XI - TRYING TO PRINT MODULE LINK OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            context2yoke['operation'] = 'write'                           
                            context2yoke['message'] = '<param name="module2node"' + ' value="'+ str(kb2node [key2node] [cc2sense] [cc2module]) + '">' + '<!-- MODULE LINK OF NODE-->'
                            yoke4xi(context2yoke)   
                               
                        except:
                            context2yoke['operation'] = 'pass'                                
                            context2yoke['message'] = '<!--' + "(Step 219Z/33) OF IMPORT2BALL4XI ** YIELDED WITH MODULE LINK OF NODE **" + '-->'
                            yoke4xi(context2yoke)   
                                             
                            context2yoke['message'] = '<param name="module"' + ' value ="telescope4xi.py">' + '<!-- MODULE PROVIDED BY TELESCOPE-->'
                            yoke4xi(context2yoke)   
   
                                                                                                                              
                        # ----------------------------------------------------------------------------------------------
                        # (Step 22/33) OF IMPORT2BALL4XI - REASON KNOWLEDGEBASE OF NODE
                        # ----------------------------------------------------------------------------------------------                                                                                                                    
                        context2yoke['operation'] = 'pass'                         
                        context2yoke['message'] = '<!--' + "(Step 219A/33) OF IMPORT2BALL4XI - TRYING TO EMBED REASON KNOWLEDGEBASE OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                          
                        try:
                            kb2reason = kb2node [key2node] [cc2reason]
                            keys2reason = kb2reason.keys()
                            for key2reason in sorted(keys2reason):
                                context2yoke['operation'] = 'write'                  
                                context2yoke['message'] = '<!--' + "sphere2reason[" + str(key2direction) + "][" + str(key2layer) + "][" + str(key2node) + "][" + str(key2reason) + "]: " + str(kb2node [key2node] [cc2reason] [key2reason]) + '-->'
                                yoke4xi(context2yoke)   
   
                        except:
                            context2yoke['operation'] = 'pass'                              
                            context2yoke['message'] = '<!--' + "(Step 22Z/33) OF IMPORT2BALL4XI *** FAILED TO EMBED REASON KNOWLEDGEBASE OF NODE ***" + '-->'
                            yoke4xi(context2yoke)   
                                         
                            
                        # ----------------------------------------------------------------------------------------------
                        # (Step 23/33) OF IMPORT2BALL4XI - ACE KNOWLEDGEBASE OF NODE
                        # ---------------------------------------------------------------------------------------------- 
                        context2yoke['operation'] = 'pass'                                 
                        context2yoke['message'] = '<!--' + "(Step 219A/33) OF IMPORT2BALL4XI - TRYING TO EMBED ACE KNOWLEDGEBASE OF NODE" + '-->'
                        yoke4xi(context2yoke)   
                                         
                        try:                                              
                            kb2ace = kb2node [key2node] [cc2ace]
                            keys2ace = kb2ace.keys()
                            for key2ace in sorted(keys2ace):
                                context2yoke['operation'] = 'write'                       
                                context2yoke['message'] = '<!--' + "sphere2ace[" + str(key2direction) + "][" + str(key2layer) + "][" + str(key2node) + "][" + str(key2ace) + "]: " + str(kb2node [key2node] [cc2ace] [key2ace]) + '-->'
                                yoke4xi(context2yoke)   
   
                        except:
                            context2yoke['operation'] = 'pass'                             
                            context2yoke['message'] = '<!--' + "(Step 22Z/33) OF IMPORT2BALL4XI *** FAILED TO EMBED ACE KNOWLEDGEBASE OF NODE ***" + '-->'
                            yoke4xi(context2yoke)   
                   
                                                  
                        # ----------------------------------------------------------------------------------------------
                        # END OF NODE OBJECT
                        # ----------------------------------------------------------------------------------------------                             
                        context2yoke['operation'] = 'write' 
                        context2yoke['message'] = '</object>'
                        yoke4xi(context2yoke)   
         
                    # ----------------------------------------------------------------------------------------------
                    # END OF LAYER OBJECT
                    # ----------------------------------------------------------------------------------------------                             
                    context2yoke['operation'] = 'write'                
                    context2yoke['message'] = '</object>'
                    yoke4xi(context2yoke)   
                                                                                                                                                                                                             
            else:
                 # ----------------------------------------------------------------------------------------------
                 # NO NODES AT LAYER
                 # ----------------------------------------------------------------------------------------------                    
                 pass
    except:
        context2yoke['operation'] = 'pass'                          
        context2yoke['message'] = '<!--' + "(Step 1Z/33) OF IMPORT2BALL4XI *** FAILED TO EMBED SPHERE TO SCOPE " + time4xi() + '-->'
        yoke4xi(context2yoke)   
             
    # ---------------------------------------------------------------------------------------------
    # END OF PARAMETERS FOR OBJECT
    # ---------------------------------------------------------------------------------------------   
        
    # ---------------------------------------------------------------------------------------------
    # END OF OBJECT
    # --------------------------------------------------------------------------------------------- 
    context2yoke['operation'] = 'write'                                          
    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
                                 

    
    # ---------------------------------------------------------------------------------------------
    # LINKS
    # --------------------------------------------------------------------------------------------- 
    context2yoke['operation'] = 'write'
    context2yoke['message'] = '</object>'
    yoke4xi(context2yoke)   
             
    context2yoke['message'] = '<br /><b>&xi;</b> <b>&raquo;</b><a href="http://www.yourdragonxi.org/sw4xi/python33/html/index2multiprocessing4xi.html" target="_blank">yoMultiProcessing4Xi</a>'
    yoke4xi(context2yoke)   
             
    # ---------------------------------------------------------------------------------------------
    # EOF BODY
    # ---------------------------------------------------------------------------------------------
    context2yoke['operation'] = 'write'
    context2yoke['message'] = '</body>'
    yoke4xi(context2yoke)   
                     
    # ---------------------------------------------------------------------------------------------
    # EOF HTML
    # ---------------------------------------------------------------------------------------------
    context2yoke['operation'] = 'write'
    context2yoke['message'] = '</html>'
    yoke4xi(context2yoke)   
    

    # ---------------------------------------------------------------------------------------------
    # (STEP 33/33) OF IMPORT2BALL4XI - CLOSE OUTPUT FILE
    # --------------------------------------------------------------------------------------------- 
    context2yoke['operation'] = 'pass'
    context2yoke['message'] = '<!--' + "(Step 33A/33) OF IMPORT2BALL4XI - TRYING TO CLOSE OUTPUT HTML FILE " + time4xi() + '-->'
    yoke4xi(context2yoke)   
        
    try: 
        context2yoke['operation']      = 'close'
        context2yoke['message'] = '<!--' + "(Step 33B/33) OF IMPORT2BALL4XI - CLOSED FILE2SCOPE: "  + path2scope + '-->'
        yoke4xi(context2yoke)   
    
    except:
        context2yoke['operation'] = 'pass'
        context2yoke['message'] = '<!--' + "(Step 33Z/33) OF IMPORT2BALL4XI *** FAILED TO CLOSE OUTPUT HTML FILE " + time4xi() + '-->'
        yoke4xi(context2yoke)   
#</function4xi>    
    
#</program4xi> 


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#
# 
#" 
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of import2ball4xi.py                      
# ------------------------------------------------------------------------------------------------- 
#"
#/>
